# arch.mk for BerkeleyGW codes
#
# suitable for Kraken at NICS
# make -j all-j causes trouble, use only -j 6
# testsuite passes 1/31/2011
#
# D. Prendergast
# Oct, 2007, Molecular Foundry

# Precompiler options
#
COMPFLAG  = -DPGI
PARAFLAG  = -DMPI
MATHFLAG  = -DUSESCALAPACK -DUNPACKED
DEBUGFLAG = -DDEBUG -DVERBOSE

FCPP    = /usr/bin/cpp -ansi
F90free = ftn -Mfree
LINK    = ftn
FOPTS   = -fast
FNOOPTS = $(FOPTS)
MOD_OPT = -module 
INCFLAG = -I

# For C++ Tools
#
C_PARAFLAG  = -DPARA -DMPICH_IGNORE_CXX_SEEK
CC_COMP = CC
C_COMP  = cc
C_LINK  = CC
C_OPTS  = -fast

REMOVE  = /bin/rm -f
#REMOVE  = /usr/local/bin/lustre-mass-delete

# Math Libraries
#
FFTWPATH     = /opt/fftw/2.1.5.3
FFTWLIB      = -L$(FFTWPATH)/lib -ldfftw
FFTWINCLUDE  = /sw/xt-cle3.1/fftw/2.1.5/cnl3.1_pgi11.6.0/fftw-2.1.5/fortran
LAPACKLIB    = 
SCALAPACKLIB = 
PERFORMANCE  = 

TESTSCRIPT = qsub kraken.scr
