# arch.mk for BerkeleyGW codes
#
# suitable for OIC at ORNL
#
# J. Deslippe
# June, 2008, UCB

# Precompiler options
#
COMPFLAG  = -DINTEL
PARAFLAG  = -DMPI
MATHFLAG  = -DUSESCALAPACK
DEBUGFLAG = -DDEBUG -DVERBOSE

FCPP    = /lib/cpp -ansi
F90free = mpif90 -FR # -quiet
LINK    = mpif90 # -quiet
FOPTS   = -O3
FNOOPTS = -O2
MOD_OPT = -module 
INCFLAG = -I

C_PARAFLAG  = -DPARA
CC_COMP = mpiCC
C_COMP  = mpicc
C_LINK  = mpiCC
C_OPTS  = -O3

REMOVE  = /bin/rm -f

# Math Libraries
#
FFTWPATH     = /home/jjd/fftw
FFTWLIB      = -L$(FFTWPATH)/lib/ -ldfftw
FFTWINCLUDE  = $(FFTWPATH)/include
MKLPATH      = /opt/intel/mkl/10.0.2.018/lib/em64t
LAPACKLIB    = -openmp -L$(MKLPATH) -lmkl_intel_lp64 -lmkl_intel_thread -lmkl_core -liomp5
SCALAPACKLIB = -L$(MKLPATH) -lmkl_scalapack_lp64 -lmkl_blacs_openmpi_lp64
