# arch.mk for BerkeleyGW codes
#
# suitable for Ranger at TACC
# must no_hires.sh in testsuite directory currently to remove time stuff from run_regression_test.pl
# all tests passed, r4840
#
# D. Strubbe
# June 2012, MIT

COMPFLAG  = -DPGI
PARAFLAG  = -DMPI
MATHFLAG  = -DUSESCALAPACK -DUNPACKED
DEBUGFLAG = -DDEBUG -DVERBOSE

FCPP    = cpp -ansi
F90free = mpif90 -Mfree
LINK    = mpif90
#FOPTS   = -g -C -O0 -check all -Warn all
FOPTS   = -fast
FNOOPTS = $(FOPTS)
MOD_OPT = -module 
INCFLAG = -I

C_PARAFLAG = -DPARA
CC_COMP = mpiCC
C_COMP  = mpicc
C_LINK  = mpiCC
C_OPTS  = -fast

REMOVE  = /bin/rm -f

# Math Libraries
#
FFTWPATH     = /opt/apps/pgi7_2/mvapich1_1_0_1/fftw2/2.1.5
FFTWLIB      = -L$(FFTWPATH)/lib -ldfftw
FFTWINCLUDE  = $(FFTWPATH)/include
LAPACKLIB    = -L/opt/apps/pgi7_2/acml/4.1.0/pgi64 -lacml
SCALAPACKDIR = /opt/apps/pgi7_2/mvapich1_1_0_1/scalapack/1.8.0/lib
SCALAPACKLIB = -L$(SCALAPACKDIR) -lscalapack $(SCALAPACKDIR)/blacs_MPI-LINUX-0.a \
  $(SCALAPACKDIR)/blacsF77init_MPI-LINUX-0.a $(SCALAPACKDIR)/blacs_MPI-LINUX-0.a

TESTSCRIPT = qsub ranger.scr
