# arch.mk for BerkeleyGW codes
#
# suitable for Titan at ORNL with PGI
# code works, testsuite script itself doesn't work at all for this environment
# note: GPUs are not used.
#
# D. Strubbe
# Jan 2013, MIT

COMPFLAG  = -DPGI
PARAFLAG  = -DMPI
MATHFLAG  = -DUSESCALAPACK -DUNPACKED
DEBUGFLAG = -DDEBUG -DVERBOSE

FCPP    = /usr/bin/cpp -ansi
F90free = ftn -Mfree -mp
LINK    = ftn -mp
#F90free = ftn -Mfree
#LINK    = ftn
FOPTS   = -fast
FNOOPTS = $(FOPTS)
MOD_OPT = -module 
INCFLAG = -I

C_PARAFLAG  = -DPARA -DMPICH_IGNORE_CXX_SEEK
CC_COMP = CC
C_COMP  = cc
C_LINK  = CC
C_OPTS  = -fast

REMOVE  = /bin/rm -f

# Math Libraries
#
FFTWPATH     = /opt/fftw/2.1.5.4
FFTWLIB      = -L$(FFTWPATH)/lib -ldfftw
FFTWINCLUDE  = $(FFTWPATH)/include

PERFORMANCE  = 

TESTSCRIPT = qsub titan.scr
